/*****************************  StringCompare.java  ***************************/

/**   Implementiert die Methoden aus dem Interface Compare
 *    und vergleicht damit zwei String-Objekte lexikografisch.
 *
 *    int compare(Object a, Object b)
 *         liefert  0, wenn a == b
 *         liefert <0, wenn a < b
 *         liefert >0, wenn a > b
 */

public class StringCompare implements Compare {

    /** vergleicht String-Objekte a und b und liefert
     *  <0, =0 oder >0
     */
    public int compare(Object a, Object b) {
        // String-Objekte vergleichen
        return ((String)a).compareTo((String)b);
    }
}
